# Run CI when these rules are true
# https://docs.gitlab.com/ee/ci/variables/predefined_variables.html
workflow:
  rules:
    - if: $CI_MERGE_REQUEST_IID
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    - if: $CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_BRANCH =~ /^release/

stages:
  - test
  - deploy

test:7.4:
  stage: test
  image: php:7.4
  before_script:
    - bash ci/docker_install.sh > /dev/null
  script:
    - composer install
    - composer test-unit

deploy:tag:
  stage: deploy
  only:
    - main
  image: php
  dependencies:
    - test:7.4
  before_script:
    - apt-get update -yqq
    - apt-get install git -yqq
  script:
    # https://www.garybell.co.uk/creating-a-release-with-gitlab-ci-and-composer/
    - VERSION="$(php -r "echo json_decode(file_get_contents('./composer.json'), true)['version'];")";
    - MESSAGE="$(php -r "echo json_encode(['name' => 'Version $VERSION', 'tag_name' => '$VERSION', 'description' => file_get_contents('./changelog/$VERSION.md')]);")";
    - git config --global user.email "brett@grofftech.net"
    - git config --global user.name "grofftech"
    - git remote add api-origin https://oauth2:${AUTH_TOKEN}@gitlab.com/${CI_PROJECT_NAMESPACE}/${CI_PROJECT_NAME}
    - >
      if [ $(git tag -l "$VERSION") ]; then
        echo "Version $VERSION already exists"
      else
        git tag -a $VERSION -m "Version $VERSION"
        git push api-origin $VERSION
        curl --header 'Content-Type: application/json' --header "PRIVATE-TOKEN: $AUTH_TOKEN" \
           --data "$MESSAGE" \
           --request POST https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/releases
      fi
